



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android工作学习第5天之Activity的传值问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android工作学习第5天之Activity的传值问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 21:53:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>注：本文大部分为网上转载，本人只是根据工作的需要略做整合！</p>
<p>本章将借用一个实例，讲解如何注册并激活一个新的Activity，以及多个Activity之间如何传值。</p>
<h2>下面是主Activity的代码：</h2>
<p><strong>[java]</strong> <a href="#" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="#" rel="external nofollow noreferrer">copy</a>&nbsp;<a href="#" rel="external nofollow noreferrer">print</a><a href="#" rel="external nofollow noreferrer">?</a></p>
<div>
<ol><li>package com.chaoyang.activity;</li>
<li>import android.app.Activity;</li>
<li>import android.content.Intent;</li>
<li>import android.os.Bundle;</li>
<li>import android.text.style.BulletSpan;</li>
<li>import android.view.View;</li>
<li>import android.widget.Button;</li>
<li>import android.widget.Toast;</li>
<li>publicclass MainActivity extends Activity {</li>
<li>/** Called when the activity is first created. */</li>
<li>@Override</li>
<li>publicvoid onCreate(Bundle savedInstanceState) {</li>
<li>super.onCreate(savedInstanceState);</li>
<li>setContentView(R.layout.main);</li>
<li>Button button =(Button)findViewById(R.id.button);</li>
<li>button.setOnClickListener(new View.OnClickListener() {</li>
<li>//给按钮注册点击事件，打开新的Acticity</li>
<li>@Override</li>
<li>publicvoid onClick(View v) {</li>
<li>// TODO Auto-generated method stub</li>
<li>//为Intent设置要激活的组件（将要激活TheOtherActivity这个Activity）</li>
<li>Intent intent =new Intent(MainActivity.this,TheOtherActivity.class);//</li>
<li>//写法一 intent.setClass(MainActivity.this, OtherActivity.class);//设置要激活的组件</li>
<li>//写法二 intent.setComponent(new ComponentName(MainActivity.this, TheOtherActivity.class));//设置要激活的组件</li>
<li>//第一种传值方式(代码看起来更加更简洁)</li>
<li>/*</li>
<li>intent.putExtra("name", "dinglang");</li>
<li>intent.putExtra("age", 22);</li>
<li>*/</li>
<li>//第二种传值方式</li>
<li>Bundle bundle =new Bundle();</li>
<li>bundle.putString("name", "dinglang");</li>
<li>bundle.putInt("age", 22);</li>
<li>intent.putExtras(bundle);</li>
<li>/*</li>
<li>Intent提供了各种常用类型重载后的putExtra()方法，如： putExtra(String name, String value)、 putExtra(String name, long value)，在putExtra()方法内部会判断当前Intent对象内部是否已经存在一个Bundle对象，如果不存在就会新建Bundle对象，以后调用putExtra()方法传入的值都会存放于该Bundle对象</li>
<li>这些其实可以通过看源码的，内部实现的原理都是一样的</li>
<li>*/</li>
<li>//startActivity(intent);//不需要接收组件的返回值，就可以直接这样激活了</li>
<li>//需要接收返回结果。注意返回的结果码</li>
<li>startActivityForResult(intent, 100);</li>
<li>}</li>
<li>});</li>
<li>}</li>
<li>@Override</li>
<li>protectedvoid onActivityResult(int requestCode, int resultCode, Intent data) {</li>
<li>// TODO Auto-generated method stub</li>
<li>Toast.makeText(this, data.getStringExtra("result"), 1).show();//得到返回结果</li>
<li>super.onActivityResult(requestCode, resultCode, data);</li>
<li>}</li>
<li>}</li></ol>
</div>
<h2>下面是otherActivity部分代码：</h2>
<h2>在相同包下，新建一个类，继承至Activity这个类,重写onCreate方法...</h2>
<div>
<ol><li>package com.chaoyang.activity;</li>
<li>import android.app.Activity;</li>
<li>import android.content.Intent;</li>
<li>import android.os.Bundle;</li>
<li>import android.view.View;</li>
<li>import android.widget.Button;</li>
<li>import android.widget.TextView;</li>
<li>publicclass TheOtherActivity extends Activity {</li>
<li>@Override</li>
<li>protectedvoid onCreate(Bundle savedInstanceState) {</li>
<li>// TODO Auto-generated method stub</li>
<li>super.onCreate(savedInstanceState);</li>
<li>setContentView(R.layout.other);//设置该Activity所对应的xml布局文件</li>
<li>Intent intent =this.getIntent();//得到激活她的意图</li>
<li>String name =intent.getStringExtra("name");</li>
<li>int age=intent.getExtras().getInt("age");//第二种取值方式</li>
<li>TextView textView = (TextView)this.findViewById(R.id.result);</li>
<li>textView.setText("姓名："+ name+"&nbsp; 年龄："+ age);</li>
<li>Button button = (Button)this.findViewById(R.id.close);</li>
<li>button.setOnClickListener(new View.OnClickListener() {</li>
<li>//返回结果给前面的Activity</li>
<li>@Override</li>
<li>publicvoid onClick(View v) {</li>
<li>// TODO Auto-generated method stub</li>
<li>Intent intent =new Intent();</li>
<li>intent.putExtra("result", "这是处理结果");</li>
<li>setResult(20, intent);//设置返回数据</li>
<li>finish();//关闭activity</li>
<li>}</li>
<li>});</li>
<li>}</li>
<li>}</li></ol>
</div>
<h2>新建Activity之间，注意要在layout文件夹中新建一个XML的布局文件。（新建Android项目时如果选择了创建Activity，会默认新建一个XML的布局文件）</h2>
<h2>下面是布局文件main.xml：</h2>
<div>
<ol><li>&lt;?xmlversion="1.0"encoding="utf-8"?&gt;</li>
<li>&lt;LinearLayoutxmlns:android="http://schemas.android.com/apk/res/android"</li>
<li>android:orientation="vertical"</li>
<li>android:layout_width="fill_parent"</li>
<li>android:layout_height="fill_parent"</li>
<li>&gt;</li>
<li>&lt;TextView</li>
<li>android:layout_width="fill_parent"</li>
<li>android:layout_height="wrap_content"</li>
<li>android:text="@string/hello"</li>
<li>/&gt;</li>
<li>&lt;Button</li>
<li>android:layout_width="wrap_content"</li>
<li>android:layout_height="wrap_content"</li>
<li>android:text="打开OtherActivity"</li>
<li>android:id="@+id/button"</li>
<li>/&gt;</li>
<li>&lt;/LinearLayout&gt;</li></ol>
</div>
<h2>下面是布局文件other.xml</h2>
<p><strong>[html]</strong> <a href="#" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="#" rel="external nofollow noreferrer">copy</a>&nbsp;<a href="#" rel="external nofollow noreferrer">print</a><a href="#" rel="external nofollow noreferrer">?</a></p>
<div>
<ol><li>&lt;?xmlversion="1.0"encoding="utf-8"?&gt;</li>
<li>&lt;LinearLayout</li>
<li>xmlns:android="http://schemas.android.com/apk/res/android"</li>
<li>android:orientation="vertical"</li>
<li>android:layout_width="fill_parent"</li>
<li>android:layout_height="fill_parent"&gt;</li>
<li>&lt;TextView</li>
<li>android:layout_width="fill_parent"</li>
<li>android:layout_height="wrap_content"</li>
<li>android:text="这是OtherActivity"</li>
<li>android:id="@+id/result"</li>
<li>/&gt;</li>
<li>&lt;Button</li>
<li>android:layout_width="wrap_content"</li>
<li>android:layout_height="wrap_content"</li>
<li>android:text="关闭Activity"</li>
<li>android:id="@+id/close"</li>
<li>/&gt;</li>
<li>&lt;/LinearLayout&gt;</li></ol>
</div>
<h2>最后，注意修改项目清单文件。在里面添加，注册新的Acticity名称</h2>
<p><strong>[html]</strong> <a href="#" rel="external nofollow noreferrer">view plain</a>&nbsp;<a href="#" rel="external nofollow noreferrer">copy</a>&nbsp;<a href="#" rel="external nofollow noreferrer">print</a><a href="#" rel="external nofollow noreferrer">?</a></p>
<div>
<ol><li>&lt;?xmlversion="1.0"encoding="utf-8"?&gt;</li>
<li>&lt;manifestxmlns:android="http://schemas.android.com/apk/res/android"</li>
<li>package="com.chaoyang.activity"</li>
<li>android:versionCode="1"</li>
<li>android:versionName="1.0"&gt;</li>
<li>&lt;uses-sdkandroid:minSdkVersion="8"/&gt;</li>
<li>&lt;applicationandroid:icon="@drawable/icon"android:label="@string/app_name"&gt;</li>
<li>&lt;activityandroid:name=".MainActivity"</li>
<li>android:label="@string/app_name"&gt;</li>
<li>&lt;intent-filter&gt;</li>
<li>&lt;actionandroid:name="android.intent.action.MAIN"/&gt;</li>
<li>&lt;categoryandroid:name="android.intent.category.LAUNCHER"/&gt;</li>
<li>&lt;/intent-filter&gt;</li>
<li>&lt;/activity&gt;</li>
<li>&lt;!-- 注意项目清单文件中要加上 --&gt;</li>
<li>&lt;activityandroid:name="TheOtherActivity"android:label="the other Activity"/&gt;</li>
<li>&lt;/application&gt;</li>
<li>&lt;/manifest&gt;</li></ol>
</div>
<pre class="prettyprint linenums">&nbsp;</pre>
<p>需要注意的知识点：</p>
<p>使用Intent组件附件数据时候，为Activity之间传值的两种写法。</p>
<p>值得一提的是Bundle类的作用</p>
<p>Bundle类用作携带数据，它类似于Map，用于存放key-value名值对形式的值。相对于Map，它提供了各种常用类型的putXxx()/getXxx()方法，如:putString()/getString()和putInt()/getInt()，putXxx()用于往Bundle对象放入数据，getXxx()方法用于从Bundle对象里获取数据。Bundle的内部实际上是使用了HashMap&lt;String, Object&gt;类型的变量来存放putXxx()方法放入的值。</p>
<p>还有就是在onActivityResult这个方法中，第一个参数为请求码，即调用startActivityForResult()传递过去的值 ，第二个参数为结果码，结果码用于标识返回数据来自哪个新Activity。都是起简单的标识作用的（不要和http协议中的404，200等状态码搞混了），可以根据自己的业务需求填写，匹配，必要时候可以根据这个去判断。</p>
<p>转载地址：<a href="http://blog.csdn.net/dinglang_2009/article/details/6888111" rel="external nofollow noreferrer">http://blog.csdn.net/dinglang_2009/article/details/6888111</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96exn3q.html">Lua中调用C函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mxn11q.html">给图像添加logo</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xxy3r9.html">monkey基本命令参数详解示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1lv1x9.html">萌货猫头鹰登录界面动画iOS实现分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdwv2e8.html">Java集合框架类图</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wvee3q.html">makeKeyAndVisible的功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn3j508.html">【转】AFNetworking之于https认证</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pjw3j8.html">自己定义progressdialog，改善用户体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjjx3r8.html">POJ 2112 Optimal Milking （二分 &plus; floyd &plus; 网络流）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mrvjn8.html">VS2010-使用&OpenCurlyDoubleQuote;预先生成事件命令行&rdquo;和&OpenCurlyDoubleQuote;后期生成事件命令行&rdquo;功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoy571q.html">C&plus;&plus;中&num;和&num;&num;的特殊使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpz4m59.html">J2EE进阶&lpar;十八&rpar;基于留言板分析SSH工作流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnje7g38.html">Mysql大量插入数据时SQL语句的优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge7ywl8.html">&lbrack;Swift-2019力扣杯春季决赛&rsqb;4&period; 有效子数组的数目</a>
		</li>
						<li><a href="https://www.batexi.com/a/95grv1zq.html">android git 过滤&period;idea文件时不起作用。</a>
		</li>
						<li><a href="https://www.batexi.com/a/9603ejv9.html">jvm 年轻代、年老代、永久代</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnd2mkq.html">当进行make命令学习是出现error trying to exec &amp;&num;39&semi;cc1&amp;&num;39&semi;&colon; execvp&colon; No such file or directory</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emjx1m9.html">迷你MVVM框架 avalonjs 学习教程16、过滤器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7egyp19.html">Extjs Vbox布局方式，以及align种类，flex，pack属性含义简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/953d6g68.html">c&plus;&plus;  &OpenCurlyQuote;nullptr&rsquo; 在此作用域中尚未声明</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/5qx5znz8.html">Javascript&period;&sol;&sol;DOM</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4k3wn9.html">Django后台post请求中的csrf token</a>
			</li>
						<li><a href="https://www.batexi.com/a/390p1vj8.html">MapReduce job&period;setNumReduceTasks&lpar;0&rpar;思考</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1ld408.html">php 屏蔽NOTICE报错机制代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96yg7n8.html">java二分查找举例讨论</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q22nl3q.html">【总结】matlab求两个序列的相关性</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z4p639.html">mysql relay log参数汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q22ervq.html">SSL安全证书-概念解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g5yo78.html">Oracle索引失效问题：WHERE C1&equals;&amp;&num;39&semi;&amp;&num;39&semi; OR C2 IN&lpar;SubQuery&rpar;，并发请求时出现大量latch&colon; cache buffers chains等待</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kvzy69.html">自己编写的一个有关安卓应用开发培训PPT</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
